Dim db = null
Dim dbname = "product_db"
Dim request
Dim database
Dim sqlRow

'put these 2 lines in extra headers in the project properties
'<script src="jsstore.js"></script>
'<script src="jsstore.worker.js"></script>

'____________________________________________________________________________'
Function SQLListToIndexedDB(databaseName, sqlList)
  sqlRow = 0
  sessionStorage.SQLToIndexDBName = databaseName
  If IsArray(sqlList) = False Then
    NSB.MsgBox("Passed data is not an array",vbOKOnly,"Not valid")
    Exit Function
  End If
  ub = UBound(sqlList)
  If ub < 0 Then
    NSB.MsgBox("Array has no elements",vbOKOnly,"Not valid")
    Exit Function
  End If
  
  For r = 0 To ub
    console.log("sqlList[" & r & "]:" & sqlList[r])
    If IsArray(sqlList[r]) Then 
      t = sqlList[r][0]
    Else
      t = sqlList[r]
    End If
    If InStr(t,"DROP TABLE") = 1 Then
      console.log("GOTO DROP TABLE")
      DropTable(t)
   ElseIf InStr(t,"CREATE TABLE") = 1 Then
     console.log("GOTO CREATE TABLE")
      CreateTable(t)
    ElseIf InStr(t,"INSERT OR REPLACE INTO") = 1 Then
      console.log("GOTO INSERT OR REPLACE INTO")
      InsertOrReplaceTable(t)
    ElseIf InStr(t,"SELECT") = 1 Then
      console.log("GOTO SELECT")
      SelectFromTable(t)
    End If
  Next r
End Function
'____________________________________________________________________________'
Function DropTable(passedSQL)
  'sqlList[0]=["DROP TABLE Maintenance;",DropTableSuccess,DropTableFail]
  s = passedSQL
  s = Replace(s,"DROP TABLE ","")
  x = InStr(s,";")
  table = Left(s,x - 1)
  console.log("DropTable:'" & table & "'")
  cleartable = connection.clear(table).then(DropTableSuccess,DropTableFail)
End Function
'____________________________________________________________________________'
Function DropTableSuccess(e)
  console.log("Drop table success")
End Function
'____________________________________________________________________________'
Function DropTableFail(e)
  console.log("Drop table fail")
End Function
'____________________________________________________________________________' 
Function CreateTable(passedSQL)
  console.log("CreateTable passedSQL:" & passedSQL)
  'create a table using the following sql command format
  '["CREATE TABLE IF NOT EXISTS Maintenance('Machkey','Machine', 'Description', 'Interval', 'IntUnit', 'Due', DueValue,'Photo', PRIMARY KEY('Machkey'));", MaintenanceSuccess,]
  s = passedSQL
  console.log("CreateTable s:" & s)
  'get the name of the table
  s = Replace(s,"CREATE TABLE IF NOT EXISTS ","")
  x = InStr(s,"(")
  table = Trim(Left(s,x - 1))
  'get primary key if any
  primarykey = ""
  x = InStr(s,", PRIMARY KEY('")
  If x > 0 Then
    t = Mid(s,x + 15)
    t = Replace(t,"'));","")
  End If
  console.log("primarykey:" & primarykey)
  'get column header names
  s = Left(s, x) 'cut off primary key function from string
  s = Mid(s, InStr(s,"(") + 1) 'cut off table name at the start
  cols = []
  cols = Split(s,",") 'get column names
  ubcols = UBound(cols)
  If ubcols < 0 Then
    console.log("No column names found when creating table " & table)
    Exit Function
  End If
  Tbl = new Object()
  Tbl.name = table
  Tbl.columns = new Object()
  For r2 = 0 To ubcols 'loop through column names.
    cols[r2] = Trim(cols[r2])
    type = "number"
    If Left(cols[r2],1) = "'" Then type = "string" 'If col is in single quotes 'col' is then a string field, else a value/number field
    cols[r2] = Replace(cols[r2],"'","")
    If Len(cols[r2]) < 1 Then Exit For
    'console.log("cols[" & r2 & "]:" & cols[r2])
    If r2 > 0 Then 'non key column
      Tbl.columns[cols[r2]] = {notNull: True, dataType: type} 
    Else
      Tbl.columns[cols[r2]] = {notNull: True, dataType: type, primaryKey: True, autoIncrement: False}
    End If
    console.log(cols[r2] & " type:" & type)
  Next r2
  console.log("Columns: " & JSON.stringify(cols,null,vbTab))
  database = new Object()
  database.name = sessionStorage.SQLToIndexDBName
  database.tables = []
  database.tables.push(Tbl)
  console.log("db:" & JSON.stringify(database,null,vbTab))
  isDbCreated1 = connection.initDb(database).then(createSuccess,createFail)
End Function
'____________________________________________________________________________'
Function createSuccess(e)
  If e = True Then
    console.log("Init db created")
    ' here you can prefill database With some data
  Else
    console.log("Init db opened")
  End If
End Function
'____________________________________________________________________________'
Function createFail()
  console.log("createFail()")
End Function
'____________________________________________________________________________'
Function InsertOrReplaceTable(passedSQL)
  console.log("InsertOrReplaceTable(passedSQL)")
  'sql command format ="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('QuadRegul','Quad','Regular service from quad dealer','1','Year','09/12/2020',1,'&nbsp;')"
  s = passedSQL
  'get the name of the table
  s = Replace(s,"INSERT OR REPLACE INTO ","")
  x = InStr(s,"(")
  table = Trim(Left(s,x - 1))
  console.log("Insert table:" & table)
  'get column header names
  s = Mid(s, InStr(s,"(") + 1) 'cut off table name at the start
  cols = Split(s,") VALUES (")
  headers = Split(cols[0],",")
  data = Split(Replace(cols[1],")",""),",")
  console.log("headers:" & headers)
  console.log("data:" & data)
  ubcols = UBound(headers)
  If ubcols < 0 Then
    console.log("Ubound(headers) < 0")
    Exit Function
  End If
  d = new Object()
  'keyFieldDataRow = -1
  arr = []
  For r2 = 0 To ubcols
    d[headers[r2]] = Replace(data[r2],"'","")
    If Left(data[r2],1) <> "'" Then d[headers[r2]] = CSng(Replace(data[r2],"'","")) 'numeric field
    arr.push(d)
  Next r2
  'create final object to write to IndexedDB
  d = new Object()
  d.into = table
  d.upsert = True  'this allows updating of a record that was previously inserted
  d.values = arr
  console.log("d:" & JSON.stringify(d,null,vbTab))
  insertCount = connection.insert(d).then(insertSuccess,insertFail)
End Function
'____________________________________________________________________________'
Function insertSuccess(e)
  console.log(e & " rows successfully inserted")
End Function
'____________________________________________________________________________'
Function insertFail(e)
  console.log(e & " fail!")
End Function
'____________________________________________________________________________'
Function SelectFromTable(passedSQL)
  'read in all data records. Not written for any conditional select commands
  'sqlList[9] = ["SELECT * from Maintenance ORDER BY DueValue ASC;", MaintenanceDataHandler,]
  s = passedSQL
  s = Replace(s,"SELECT * FROM ","")
  w = InStr(s," ") - 1
  table = Left(s,w) 'get table name
  console.log("Select from table:'" & table & "' w:" & w)
  d = {from: table}
  sortorder = "none"
  x = InStr(s,"ORDER BY ")
  If x > 0 Then
    orderCol = Mid(s,x + 9)
    If InStr(s," ASC") > 0 Then
      sortorder = "asc"
      orderCol = Replace(orderCol," ASC;","")
    ElseIf InStr(s," DESC") > 0 Then
      sortorder = "desc"
      orderCol = Replace(orderCol," DESC;","")
    End If
    d.order = {by: orderCol, type: sortorder}
    console.log("Select d:" & JSON.stringify(d,null,vbTab))
  End If
  results = connection.select(d).then(resultsSuccess,resultsFail)
End Function
'____________________________________________________________________________'
Function resultsSuccess(e)
  console.log("resultsSuccess: e:" & e)
  console.log("Results: " & JSON.stringify(e,null,vbTab))
End Function
'____________________________________________________________________________'
Function resultsFail(e)
  console.log("resultsFail: e:" & JSON.stringify(e,null,vbTab))
End Function
'____________________________________________________________________________'
Function RunSQLButton_onclick()
  sqlList = []
  sqlList[0]=["DROP TABLE Maintenance;",DropTableSuccess,DropTableFail]
  sqlList[1]=["CREATE TABLE IF NOT EXISTS Maintenance('Machkey','Machine', 'Description', 'Interval', 'IntUnit', 'Due', DueValue,'Photo', PRIMARY KEY('Machkey'));", createSuccess,]
  sqlList[2]="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('QuadRegul','Quad','Regular service from quad dealer','1','Year','09/12/2020',1,'&nbsp;')"
  sqlList[3]="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('QuadCheck','Quad','Check tyre pressure','1','Year','10/12/2020',2,'&nbsp;')"
  sqlList[4]="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('TractorRegul','Tractor','Regular service from tractor dealer','1','Year','12/19/2020',3,'&nbsp;')"
  sqlList[5]="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('FeedoutwagonGreas','Feedout wagon','Grease all grease nipples. Check tyre pressure','1','Year','11/12/2020',4,'&nbsp;')"
  sqlList[6]="INSERT OR REPLACE INTO Maintenance (Machkey,Machine,Description,Interval,IntUnit,Due,DueValue,Photo) VALUES ('WaterpumpCheck','Water pump','Check intake3 screen and output','1','Year','02/15/2021',5,'&nbsp;')"
  sqlList[7] = ["SELECT * FROM Maintenance ORDER BY DueValue ASC;", resultsSuccess,]
  'Sql(SafeDB, sqlList)  'replace this with the next line
  SQLListToIndexedDB("SafeDB", sqlList)
End Function
'____________________________________________________________________________'
Function Main()
  txtResults.height = window.innerHeight - 320
  console.log("Main()")
  connection = new JsStore.Connection(new Worker("jsstore.worker.js"))
  console.log("connection:" & connection)
End Function
'____________________________________________________________________________'
Function btnCreateJsStoredb_onclick()
  ProductTbl = new Object()
  ProductTbl.name = "Product"
  ProductTbl.columns = new Object()
  ProductTbl.columns.id = new Object()
  ProductTbl.columns.id.primaryKey = True
  ProductTbl.columns.id.autoIncrement = False
  ProductTbl.columns.itemName = {notNull: True, dataType: "string"}
  ProductTbl.columns.price = {notNull: True, dataType: "number" }
  ProductTbl.columns.quantity = {notNull: True, dataType: "number" }
  database = new Object()
  database.name = dbname
  database.tables = []
  database.tables.push(ProductTbl)
  console.log("db:" & JSON.stringify(database,null,vbTab))
  isDbCreated1 = connection.initDb(database).then(createSuccess2,createFail2)
End Function
'____________________________________________________________________________'
Function createSuccess2(e)
  If e = True Then
    LogIt("Init db created")
    ' here you can prefill database With some data
  Else
    LogIt("Init db opened")
  End If
End Function
'____________________________________________________________________________'
Function createFail2()
  console.log("createFail()")
End Function
'____________________________________________________________________________'
Function LogIt(s)
  txtResults.value = txtResults.value & s + vbCRLF
End Function
'____________________________________________________________________________'
Function btnInsertData_onclick()
  If Len(ProductInput.value) < 1 Then
    NSB.MsgBox("Product name needed",vbOKOnly,"Name")
    Exit Function
  ElseIf Len(PriceInput.value) < 1 Then
    NSB.MsgBox("Price needed",vbOKOnly,"Price")
    Exit Function
  ElseIf Len(QuantityInput.value) < 1 Then
    NSB.MsgBox("Quantity needed",vbOKOnly,"Quantity")
    Exit Function
  End If
  Data = new Object()
  Data.id = ProductInput.value
  Data.itemName = ProductInput.value
  Data.price = CSng(PriceInput.value)
  Data.quantity = CSng(QuantityInput.value)
  arr = []
  arr.push(Data)
  d = new Object()
  d.into = "Product"
  d.upsert = True  'this allows updating of a record that was previously inserted
  d.values = arr
  console.log("d:" & JSON.stringify(d,null,vbTab))
  insertCount = connection.insert(d).then(insertSuccess2,insertFail2)
End Function
'____________________________________________________________________________'
Function insertSuccess2(e)
  LogIt("Insert success")
  LogIt(e & " rows inserted")
  console.log(e & " rows inserted")
End Function
'____________________________________________________________________________'
Function insertFail2(e)
  LogIt("Insert Fail!!!")
  console.log(e & " fail!")
End Function
'____________________________________________________________________________'
Function btnReadData_onclick()
  d = new Object()
  d.from = "Product"
  d.order = new Object()
  d.order.by = "itemName"
  d.order.type = "desc" 'or "asc"
  results = connection.select(d).then(resultsSuccess2,resultsFail2)
End Function
'____________________________________________________________________________'
Function resultsSuccess2(e)
  console.log("resultsSuccess2: e:" & e)
  LogIt(JSON.stringify(e,null,vbTab))
End Function
'____________________________________________________________________________'
Function resultsFail2(e)
  console.log("resultsFail2: e:" & e)
End Function
'____________________________________________________________________________'
Function btnClearData_onclick()
  cleartable = connection.clear("Product").then(ClearSuccess2,ClearFail2)
End Function
'____________________________________________________________________________'
Function ClearSuccess2(e)
  console.log("ClearSuccess2")
  LogIt(JSON.stringify(e,null,vbTab))
End Function
'____________________________________________________________________________'
Function ClearFail2(e)
  console.log("ClearFail2")
End Function

